"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ReactDOM = require("react-dom");
var generateWindowFeaturesString_1 = require("./generateWindowFeaturesString");
var popouts_1 = require("./popouts");
var crossBrowserCloneNode_1 = require("./crossBrowserCloneNode");
var UNIQUE_NAME = '__$$REACT_POPOUT_COMPONENT$$__';
var Popout = /** @class */ (function (_super) {
    __extends(Popout, _super);
    function Popout() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.openChildWindow = function () {
            var options = generateWindowFeaturesString_1.generateWindowFeaturesString(_this.props.options || {});
            var name = getWindowName(_this.props.name);
            _this.child = window.open('about:blank', name, options);
            _this.id = "__" + name + "_container__";
            _this.container = _this.initializeChildWindow(_this.id, _this.child);
        };
        _this.closeChildWindowIfOpened = function () {
            if (isChildWindowOpened(_this.child)) {
                _this.child.close();
                _this.child = null;
                if (_this.props.onClose) {
                    _this.props.onClose();
                }
            }
        };
        return _this;
    }
    Popout.prototype.setupCleanupCallbacks = function () {
        var _this = this;
        // Close the popout if main window is closed.
        window.addEventListener('unload', function (e) { return _this.closeChildWindowIfOpened(); });
        if (!window[UNIQUE_NAME]) {
            window[UNIQUE_NAME] = {
                onChildClose: function (id) {
                    if (popouts_1.popouts[id].props.onClose) {
                        popouts_1.popouts[id].props.onClose();
                    }
                },
            };
        }
    };
    Popout.prototype.setupStyleElement = function (child) {
        if (!this.styleElement) {
            this.styleElement = child.document.createElement('style');
            this.styleElement.setAttribute('data-this-styles', 'true');
            this.styleElement.type = 'text/css';
            child.document.head.appendChild(this.styleElement);
        }
        for (var i = document.styleSheets.length - 1; i >= 0; i--) {
            var styleSheet = document.styleSheets[i];
            for (var ruleIndex = 0; ruleIndex < styleSheet.cssRules.length; ruleIndex++) {
                this.styleElement.sheet.insertRule(styleSheet.cssRules[ruleIndex].cssText, 0);
            }
        }
    };
    Popout.prototype.initializeChildWindow = function (id, child) {
        popouts_1.popouts[id] = this;
        if (this.props.html) {
            child.document.write(this.props.html);
        }
        // Create a container element
        var container = child.document.createElement('div');
        container.id = id;
        // Create a document with the styles of the parent window first
        this.setupStyleElement(child);
        child.document.body.appendChild(container);
        var unloadScriptContainer = child.document.createElement('script');
        unloadScriptContainer.innerHTML = "window.onbeforeunload = function(e) { window.opener." + UNIQUE_NAME + ".onChildClose.call(window.opener, '" + id + "'); }";
        child.document.body.appendChild(unloadScriptContainer);
        this.setupCleanupCallbacks();
        // Add style observer for legacy style node additions
        var observer = new MutationObserver(function (mutations) {
            mutations.forEach(function (mutation) {
                if (mutation.type == 'childList') {
                    forEachStyleElement(mutation.addedNodes, function (element) {
                        child.document.head.appendChild(crossBrowserCloneNode_1.crossBrowserCloneNode(element, child.document));
                    });
                }
            });
        });
        var config = { childList: true };
        observer.observe(document.head, config);
        return container;
    };
    Popout.prototype.componentDidMount = function () {
        if (!this.props.hidden && !isChildWindowOpened(this.child)) {
            this.openChildWindow();
        }
    };
    Popout.prototype.componentWillUnmount = function () {
        this.closeChildWindowIfOpened();
    };
    Popout.prototype.render = function () {
        if (!this.props.hidden) {
            if (!isChildWindowOpened(this.child)) {
                this.openChildWindow();
            }
            return ReactDOM.createPortal(this.props.children, this.container);
        }
        else {
            this.closeChildWindowIfOpened();
            return null;
        }
    };
    return Popout;
}(React.Component));
exports.Popout = Popout;
function isChildWindowOpened(child) {
    return child && !child.closed;
}
function getWindowName(name) {
    return (name ||
        Math.random()
            .toString(12)
            .slice(2));
}
function forEachStyleElement(nodeList, callback, scope) {
    var element;
    for (var i = 0; i < nodeList.length; i++) {
        element = nodeList[i];
        if (element.tagName == 'STYLE' || element.tagName == 'LINK') {
            callback.call(scope, element, i);
        }
    }
}
